unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls,
  UnitFunc ;

type
  TForm2 = class(TForm)
    Panel1: TPanel;
    RichEdit1: TRichEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    FontDialog1: TFontDialog;
    Button5: TButton;
    Button6: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    docs : string ;
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

// N
procedure TForm2.FormShow(Sender: TObject);
var
   i,c : integer ;
   s,ss : string ;
   bn : string ;
   bm,bh,bc : integer ;
   bs : TFontStyles ;
begin
   with RichEdit1 do begin
      Visible := False ;
      SelStart := 0 ;
      SelLength := 0 ;
      Text := '' ;
      Paragraph.Alignment := taLeftJustify ;
      Paragraph.Numbering := nsNone ;
      SelAttributes.Name   := 'lr SVbN';
      SelAttributes.Charset:= DEFAULT_CHARSET ;
      SelAttributes.Height := 13 ;
      SelAttributes.Color  := $000000 ;
      SelAttributes.Style  := [] ;
      i := 1 ;
      while (i <= Length(docs)) do begin
         s := Copy(docs,i,1);
         if (s = '\') then begin
            Inc(i);
            s := Copy(docs,i,1);
            if (s = 'A') then begin
               Inc(i);
               s := Copy(docs,i,1);
               Case (SInt(s)) of
               1: Paragraph.Alignment := taLeftJustify ;
               2: Paragraph.Alignment := taCenter ;
               3: Paragraph.Alignment := taRightJustify ;
               end;
            end
            else if (s = 'K') then begin
               ss := '' ;
               while (i < Length(docs)) do begin
                  Inc(i);
                  s := Copy(docs,i,1);
                  if (s = ';')or(s = '\') then break
                  else ss := ss + s ;
               end;
               c := SInt(ss);
               if (c >= 0)and(c <= 1638) then begin
                  Paragraph.Numbering := nsBullet ;
                  Paragraph.FirstIndent := c ;
               end;
            end
            else if (s = 'N') then begin
               bn := SelAttributes.Name  ;
               bm := SelAttributes.Charset;
               bh := SelAttributes.Height;
               bc := SelAttributes.Color ;
               bs := SelAttributes.Style ;
               SelStart := Length(Text);
               SetSelText(#13);
               Paragraph.Numbering := nsNone ;
               Paragraph.FirstIndent := 0 ;
               SelAttributes.Name   := bn ;
               SelAttributes.Charset:= bm ;
               SelAttributes.Height := bh ;
               SelAttributes.Color  := bc ;
               SelAttributes.Style  := bs ;
            end
            else if (s = 'T') then begin
               SelStart := Length(Text);
               SetSelText(#9);
            end
            else if (s = 'F') then begin
               ss := '' ;
               while (i < Length(docs)) do begin
                  Inc(i);
                  s := Copy(docs,i,1);
                  if (s = ';')or(s = '\') then break
                  else ss := ss + s ;
               end;
               SelAttributes.Name := ss ;
            end
            else if (s = 'M') then begin
               ss := '' ;
               while (i < Length(docs)) do begin
                  Inc(i);
                  s := Copy(docs,i,1);
                  if (s = ';')or(s = '\') then break
                  else ss := ss + s ;
               end;
               c := SInt(ss);
               if (c >= 0)and(c <= 255) then begin
                  SelAttributes.Charset := c ;
               end;
            end
            else if (s = 'H') then begin
               ss := '' ;
               while (i < Length(docs)) do begin
                  Inc(i);
                  s := Copy(docs,i,1);
                  if (s = ';')or(s = '\') then break
                  else ss := ss + s ;
               end;
               c := SInt(ss);
               if (c >= 1)and(c <= 1638) then begin
                  SelAttributes.Height := c ;
               end;
            end
            else if (s = 'C') then begin
               Inc(i);
               s := Copy(docs,i,6);
               i := i + 5 ;
               c := SInt('$'+s);
               if (c >= $000000)and(c <= $ffffff) then begin
                  SelAttributes.Color := c ;
               end;
            end
            else if (s = 'B') then SelAttributes.Style := SelAttributes.Style + [fsBold]
            else if (s = 'b') then SelAttributes.Style := SelAttributes.Style - [fsBold]
            else if (s = 'I') then SelAttributes.Style := SelAttributes.Style + [fsItalic]
            else if (s = 'i') then SelAttributes.Style := SelAttributes.Style - [fsItalic]
            else if (s = 'U') then SelAttributes.Style := SelAttributes.Style + [fsUnderline]
            else if (s = 'u') then SelAttributes.Style := SelAttributes.Style - [fsUnderline]
            else if (s = 'S') then SelAttributes.Style := SelAttributes.Style + [fsStrikeOut]
            else if (s = 's') then SelAttributes.Style := SelAttributes.Style - [fsStrikeOut]
            else if (s = 'c') then begin
               SelAttributes.Style := [] ;
            end;
         end
         else begin
            SelStart := Length(Text);
            SetSelText(s);
         end;
         Inc(i);
      end;
      Visible := True ;
   end;
end;

// I
procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
var
   za : integer ;
   zf : string ;
   zm,zh,zc : integer ;
   zb,zi,zu,zs : Boolean ;
   i,c : integer ;
   s : string ;
begin
   docs := '' ;
   za := 0 ;
   zf := 'lr SVbN';
   zm := DEFAULT_CHARSET;
   zh := 13 ;
   zc := $000000 ;
   zb := False ;
   zi := False ;
   zu := False ;
   zs := False ;
   with RichEdit1 do begin
      Visible := False ;
      SelStart := 0 ;
      SelLength := 0 ;
      // 
      case (Paragraph.Alignment) of
      taLeftJustify :
         if (za <> 1) then begin
            za := 1 ;
            docs := docs + '\A1';
         end;
      taCenter :
         if (za <> 2) then begin
            za := 2 ;
            docs := docs + '\A2';
         end;
      taRightJustify :
         if (za <> 3) then begin
            za := 3 ;
            docs := docs + '\A3';
         end;
      end;
      // ӏ
      if (Paragraph.Numbering = nsBullet) then begin
         docs := docs + '\K' + IntToStr(Paragraph.FirstIndent) + ';';
      end;
      //
      docs := docs + '\F' + zf + ';\M' + IntToStr(zm) + ';\H' + IntToStr(zh) + ';\C' + IntToHex(zc,6) ;
      //
      for i:=1 to Length(Text) do begin
         SelStart := i - 1 ;
         SelLength := 1 ;
         s := SelText ;
         if (s = #13) then begin
            // s
            docs := docs + '\N';

            SelStart := i ;
            SelLength := 1 ;
            case (Paragraph.Alignment) of
            taLeftJustify :
               if (za <> 1) then begin
                  za := 1 ;
                  docs := docs + '\A1';
               end;
            taCenter :
               if (za <> 2) then begin
                  za := 2 ;
                  docs := docs + '\A2';
               end;
            taRightJustify :
               if (za <> 3) then begin
                  za := 3 ;
                  docs := docs + '\A3';
               end;
            end;
            if (Paragraph.Numbering = nsBullet) then begin
               docs := docs + '\K' + IntToStr(Paragraph.FirstIndent) + ';';
            end;

            continue ;
         end
         else if (s < #32)and(s <> #9) then continue ;    // Rg[R[h(^uȊO)
         //
         // tHg
         if (zf <> SelAttributes.Name) then begin
            zf := SelAttributes.Name ;
            docs := docs + '\F' + zf + ';';
         end;
         // Zbg
         if (zm <> SelAttributes.Charset) then begin
            zm := SelAttributes.Charset ;
            docs := docs + '\M' + IntToStr(zm) + ';';
         end;
         // 傫
         if (zh <> SelAttributes.Height) then begin
            zh := SelAttributes.Height ;
            docs := docs + '\H' + IntToStr(zh) + ';';
         end;
         // F
         c  := ColorTORGB(SelAttributes.Color) ;
         if (zc <> c) then begin
            zc := c ;
            docs := docs + '\C' + IntToHex(zc,6) ;
         end;
         // X^C
         if (SelAttributes.Style = []) then begin
            if (zb)or(zi)or(zu)or(zs) then begin
               zb := False ;
               zi := False ;
               zu := False ;
               zs := False ;
               docs := docs + '\c' ;
            end;
         end
         else begin
            if (fsBold      in SelAttributes.Style) then begin
               if not(zb) then begin
                  zb := True ;
                  docs := docs + '\B' ;
               end;
            end
            else begin
               if (zb) then begin
                  zb := False ;
                  docs := docs + '\b' ;
               end;
            end;
            if (fsItalic    in SelAttributes.Style) then begin
               if not(zi) then begin
                  zi := True ;
                  docs := docs + '\I' ;
               end;
            end
            else begin
               if (zi) then begin
                  zi := False ;
                  docs := docs + '\i' ;
               end;
            end;
            if (fsUnderline in SelAttributes.Style) then begin
               if not(zu) then begin
                  zu := True ;
                  docs := docs + '\U' ;
               end;
            end
            else begin
               if (zu) then begin
                  zu := False ;
                  docs := docs + '\u' ;
               end;
            end;
            if (fsStrikeOut in SelAttributes.Style) then begin
               if not(zs) then begin
                  zs := True ;
                  docs := docs + '\S' ;
               end;
            end
            else begin
               if (zs) then begin
                  zs := False ;
                  docs := docs + '\s' ;
               end;
            end;
         end;
         //
         if (s = #9 ) then begin
            // ^u
            docs := docs + '\T';
         end
         else begin
            // ʏ핶
            docs := docs + s ;
         end;
      end;
   end;
end;

// []
procedure TForm2.Button1Click(Sender: TObject);
begin
   FontDialog1.Font.Name   := RichEdit1.SelAttributes.Name ;
   FontDialog1.Font.Charset:= RichEdit1.SelAttributes.Charset ;
   FontDialog1.Font.Height :=-RichEdit1.SelAttributes.Height ;
   FontDialog1.Font.Color  := RichEdit1.SelAttributes.Color ;
   FontDialog1.Font.Style  := RichEdit1.SelAttributes.Style ;
   if (FontDialog1.Execute) then begin
      RichEdit1.SelAttributes.Name     := FontDialog1.Font.Name   ;
      RichEdit1.SelAttributes.Charset  := FontDialog1.Font.Charset;
      RichEdit1.SelAttributes.Height   :=-FontDialog1.Font.Height ;
      RichEdit1.SelAttributes.Color    := FontDialog1.Font.Color  ;
      RichEdit1.SelAttributes.Style    := FontDialog1.Font.Style  ;
   end;
   RichEdit1.SetFocus ;
end;

// []
procedure TForm2.Button2Click(Sender: TObject);
begin
   RichEdit1.Paragraph.Alignment := taLeftJustify ;
   RichEdit1.SetFocus ;
end;

// []
procedure TForm2.Button3Click(Sender: TObject);
begin
   RichEdit1.Paragraph.Alignment := taCenter ;
   RichEdit1.SetFocus ;
end;

// [E]
procedure TForm2.Button4Click(Sender: TObject);
begin
   RichEdit1.Paragraph.Alignment := taRightJustify ;
   RichEdit1.SetFocus ;
end;

// [Ȃ]
procedure TForm2.Button5Click(Sender: TObject);
begin
   RichEdit1.Paragraph.Numbering := nsNone ;
   RichEdit1.Paragraph.FirstIndent := 0 ;
   RichEdit1.SetFocus ;
end;

// [ӏ]
procedure TForm2.Button6Click(Sender: TObject);
begin
   RichEdit1.Paragraph.Numbering := nsBullet ;
   RichEdit1.Paragraph.FirstIndent := SInt(Edit1.Text);
   RichEdit1.SetFocus ;
end;

end.
